/* This demo was written to show a way for players to turn a channel on or off. For the demo
   I'll keep the amount of channels I use down to 3. One last thing:
   It's my first demo so bear with me.													*/



world/name = "Channels Demo"

mob/var/channels = list("chat", "trivia", "ooc")// This will be a list of channels the player has on.
												// When a player wants to turn a channel off, it
												// will be removed from the list. If they want to
												// turn one on it will be added.
												// You'll see what I mean when we get there.

mob/Login()
	..()
	world << "[src] has entered."// Alert everyone when someone has entered

mob/Logout()
	..()
	world << "[src] has left."// Report when someone leaves the world
	del(src) // Erase them from the world! *evil laugh*


mob/verb/chat(msg as text)
	if("chat" in usr.channels)// If chat is ON
		var/mob/M
		for(M in world)
			if("chat" in M:channels)
				M << "[usr] chats: [html_encode(msg)]"// Meet your new best friend, html_encode
			else
				return
		return
	else // If chat is OFF
		usr << "You can't use the channel if it isn't turned on!"
		return




mob/verb/trivia(msg as text)// I'm assuming I only needed chat commented
	if("trivia" in usr.channels)
		var/mob/M
		for(M in world)
			if("trivia" in M:channels)
				M << "(TRIVIA) [usr]: [html_encode(msg)]"
			else
				return
		return
	else
		usr << "You can't use the channel if it isn't turned on!"
		return

mob/verb/ooc(msg as text)
	if("ooc" in usr.channels)
		var/mob/M
		for(M in world)
			if("ooc" in M:channels) // Only send this to players with the channel on
				M << "(OOC) [usr]: [html_encode(msg)]"
			else
				return
		return
	else
		usr << "You can't use the channel if it isn't turned on!"
		return



mob/verb/channels() // This is the fun verb. It will toggle a
					// channel on or off by removing or adding
					// it to the channels list.
	var/C = input("What channel would you like to toggle on/off?") in list("Chat", "Trivia", "OOC", "All")
	switch(C)
		if("Chat")
			if("chat" in usr.channels) // If they have chat turned on...
				usr.channels -= "chat" // Remove chat from their list of channels that are on
				usr << "You have turned chat OFF."
				return
			else // Otherwise if chat is off...
				usr.channels += "chat" // Add chat to their list of channels that are on
				usr << "You have turned chat ON."
				return
		if("Trivia") // Trivia and OOC follow the same steps
			if("trivia" in usr.channels)
				usr.channels -= "trivia"
				usr << "You have turned trivia OFF."
				return
			else
				usr.channels += "trivia"
				usr << "You have turned trivia ON."
				return
		if("OOC")
			if("ooc" in usr.channels)
				usr.channels -= "ooc"
				usr << "You have turned ooc OFF."
				return
			else
				usr.channels += "ooc"
				usr << "You have turned ooc ON."
				return
// Ok, this part was fun, I've been looking around for a while trying to figure out how to check
// if the channel was in the list already.
		if("All")
			switch(alert("Turn all channels on or off?",, "On", "Off"))//Pop up an alert box
																	   //to get user input
				if("On") // If they clicked the "On" button
					if("chat" in usr.channels) // check if a channel is on or off...
					else // If it's off
						usr.channels += "chat" // turn it back on
					if("trivia" in usr.channels) // Wow, seems pretty repetetive!
					else
						usr.channels += "trivia"
					if("ooc" in usr.channels)
					else
						usr.channels += "ooc"

				if("Off") // If they clicked the "Off" button
					// Off really doesn't require any special checks. Just remove the channel from the list!
					usr.channels -= "chat"
					usr.channels -= "trivia"
					usr.channels -= "ooc"
					usr << "You turned all the channels off."








